function w = EXTRAPOL(f,a,b,k)
% w = EXTRAPOL(f,a,b,k)
%
% Extrapolation zur summierten Trapezregel der Funktion f auf dem Intervall 
% [a,b] und quidistanten Unterteilung
% x_i = a + i * h, i = 0,1,...,l;   h = (b-a)/(2^l), l = 0,...,k 
%                                   (Romberg-Folge)
%
% Input
% f       auszuwertende Funktion im Intervall [a,b]
% a,b     Intervallgrenzen a,b
% k       Zweierpotenz, 2^k ist die maximale Anzahl Unterteilungen. Das 
%         Intervall [a,b] wird sukzessive halbiert.
%
% Output  
% w       Werte der summierten Regel zur Unterteilung in 1,2,4,8,...,2^k
%         quidistante Intervalle. Die Auswertung mittels Neville-Schema
%         liefert nicht nur die Werte der Extrapolation zur Unterteilung in
%         2^k gleichgroe Stcke, sondern die Werte der Extrapolation zur
%         Unterteilung in 1,2,...,2^k . D.h. der Vektor w enthaelt die
%         gesamte untere Zeile des Neville-Aitken-Schemas.
