% Whle maximale Anzahl Sttzstellen als Zweierpotenz zum besseren Vergleich
% mit der Extrapolation
l=9; % Hier 2^l

k=menu('Integration mittels summierter Regeln',...
       'Trapezregel',...
       'Mittelpunktregel',...
       'Simpsonregel',...
       'Extrapolation',...
       'Vergleich aller',...
       'Ende');
   
while k<6

      lf=menu('Funktion',...
	      'int sin(x) auf  [0,pi/2]',...
	      'int x^(1/2) auf [0,1]',...
	      'int x^(3/2) auf [0,1]',...
	      'int x^(5/2) auf [0,1]');
      if lf==1
	 fname='sin';
	 a=0; b=pi/2;
         intexakt=1;
      elseif lf==2
	 fname='FUNKTION3';
	 a=0; b=1;
         intexakt=2/3;
      elseif lf==3
	 fname='FUNKTION4';
	 a=0; b=1;
         intexakt=2/5;
      elseif lf==4
	 fname='FUNKTION5';
	 a=0; b=1;
         intexakt=2/7;
      end
	
	
	
      w =zeros(4,l+1);
      fl=zeros(4,l+1);
      m =zeros(1,l+1);
                 
      N=1;
      for i=1:l+1

	    % stckweise Trapezregel zur geg. Funktion f auf [a,b]
	    if k==1 | k==5
	       tic;
	       w(1,i) =TRAPEZ(fname,a,b,N);
	       fl(1,i)=toc;
	    end % if
	    
	    % stckweise Mittelpunktregel zur Funktion f auf [a,b]
	    if k==2 | k==5
	       tic;
	       w(2,i) =MITTELP(fname,a,b,N);
	       fl(2,i)=toc;
	    end % if
	    
	    % stckweise Simpsonregelregel zur Funktion f auf [a,b]
	    % N=1 nicht mglich fr summierte Simpson-Regel
	    if (k==3 | k==5) & N>1
	       tic;
	       w(3,i) =SIMPSON(fname,a,b,N);
	       fl(3,i)=toc;
	    end % if
	     
	    % Extrapolation zur Summierten Trapezregel 
	    % zur Funktion f auf [a,b]
	    if k==4 | k==5
	       tic;
               wtmp   =EXTRAPOL(fname,a,b,i);
	       fl(4,i)=toc;
	       w(4,i) =wtmp(i+1);
	    end % if

	    m(i)=N;
	    N=N*2;
      end;

      % Grafische Auswertung, Teil 1: Fehler
      figure(1);
      txt='N, ';
      if k==1 | k==5
         loglog(m, abs(intexakt-w(1,:)), '+r');
	 txt=[txt '`+` Trapez, '];
	 hold on;
      end % if
	    
      if k==2 | k==5
	 loglog(m, abs(intexakt-w(2,:)), 'ob');
	 txt=[txt '`o` Mittelpunkt, '];
      end % if

      if k==3 | k==5
	 loglog(m, abs(intexakt-w(3,:)), 'xm');
	 txt=[txt '`x` Simpson'];
      end % if
      
      if k==4 | k==5
	 loglog(m, abs(intexakt-w(4,:)), '*g');
	 txt=[txt '`*` Extrapolation'];
      end % if

      hold off;
      xlabel(txt);
      ylabel('Fehler');
      title('Genauigkeit der summierten Regel(n) / Extrapolation')
      

      % Grafische Auswertung, Teil 2: CPU-Zeit
      figure(2)
      if k==1 | k==5
	 loglog(m, fl(1,:), '+r');
	 hold on;
      end % if
      if k==2 | k==5
	 loglog(m, fl(2,:), 'ob');
      end % if
      if k==3 | k==5
	 loglog(m, fl(3,:), 'xm');
      end % if
      if k==4 | k==5
	 loglog(m, fl(4,:), '*g');
      end % if

      hold off;
      xlabel(txt);
      ylabel('CPU-Zeit');
      title('Rechenzeit der summierten Regel(n) / Extrapolation');

      % Grafische Auswertung, Teil 3: Genauigkeit vs. CPU-Zeit
      figure(3)
      if k==1 | k==5
	 loglog(fl(1,:),abs(intexakt-w(1,:)), '+r');
	 hold on;
      end % if
      if k==2 | k==5
	 loglog(fl(2,:),abs(intexakt-w(2,:)), 'ob');
      end % if
      if k==3 | k==5
	 loglog(fl(3,:),abs(intexakt-w(3,:)), 'xm');
      end % if
      if k==4 | k==5
	 loglog(fl(4,:),abs(intexakt-w(4,:)), '*g');
      end % if

      hold off;
      ylabel('Fehler');
      xlabel(['CPU-Zeit, ',txt(4:end)]);
      title('Genauigkeit vs. Rechenzeit der summierten Regel(n) / Extrapolation');

      k=menu('Integration mittels summierter Regeln',...
             'Trapezregel',...
	     'Mittelpunktregel',...
	     'Simpsonregel',...
	     'Extrapolation',...
	     'Vergleich aller',...
	     'Ende');
	
end % while 
